| Qore Programming Language Reference Manual 2.2.0

Loading...
Searching...
No Matches
Public Member Functions | List of all members
Qore::InputStream Class Reference

This class defines an abstract interface for input streams. More...

`#include <QC_InputStream.dox.h>`

Inheritance diagram for Qore::InputStream:
[legend]

## Public Member Functions
| constructor ()
| Constructor.
abstract int | peek ()
| Peeks the next byte available from the input stream; returns -1 if no more data available.
abstract *binary | read (int limit)
| Reads bytes (up to a specified limit) from the input stream; returns NOTHING if there are no more bytes in the stream.
Public Member Functions inherited from Qore::StreamBase
| constructor ()
| Throws an exception if called directly; this class can only be instantiated by builtin subclasses.
int | getThreadId ()
| Get the currently assigned thread id or -1 if not assigned to any thread.
nothing | reassignThread ()
| Reassigns current thread as thread used for stream manipulation.
nothing | unassignThread ()
| Unassigns current thread as thread used for stream manipulation.

## Detailed Description

This class defines an abstract interface for input streams.

Classes inheriting this class can be used to read bytes from various sources.

See also
  StreamReader for a class that can be used to read various kinds of data from an InputStream

Note
  stream classes are not designed to be accessed from multiple threads; they have been implemented without locking for fast and efficient use when used from a single thread. For methods that would be unsafe to use in another thread, any use of such methods in threads other than the thread where the constructor was called will cause a `STREAM-THREAD-ERROR` to be thrown, unless the stream is handed off to another thread using the StreamBase::unassignThread() method in the thread that currently owns the stream, and the StreamBase::reassignThread() method in the new thread.

Since
  Qore 0.8.13

## Member Function Documentation

## ◆ constructor()

Qore::InputStream::constructor | ( |  | ) |

Constructor.

Used by subclasses defined in the Qore programming language.

## ◆ peek()

abstract int Qore::InputStream::peek | ( |  | ) |

Peeks the next byte available from the input stream; returns -1 if no more data available.

Returns
  the next byte available from the input stream or -1 if no more data is available

Example:
  int nextByte = is.peek();

## ◆ read()

abstract *binary Qore::InputStream::read | ( | int | limit | ) |

Reads bytes (up to a specified limit) from the input stream; returns NOTHING if there are no more bytes in the stream.

Parameters

  limit | the maximum number of bytes to read

Returns
  the read bytes (the length is between 1 and `limit` inclusive) or NOTHING if no more bytes are available

Example:
  *binary b;
  while (b = is.read(10)) {
  printf("Read: %y\n", b);
  }